using System;
using System.Diagnostics;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;

namespace GGC_SummaryRow_Custom
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(0, 32);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(584, 352);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = true;
			this.gridGroupingControl1.VersionInfo = "4.201.0.37";
			this.gridGroupingControl1.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridGroupingControl1_QueryCellStyleInfo);
			this.gridGroupingControl1.SourceListRecordChanged += new Syncfusion.Grouping.RecordChangedEventHandler(this.gridGroupingControl1_SourceListRecordChanged);
			// 
			// button1
			// 
			this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.button1.Location = new System.Drawing.Point(456, 392);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(112, 24);
			this.button1.TabIndex = 1;
			this.button1.Text = "Export to Excel";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(584, 422);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "GGC_SummaryRow_Custom...";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.gridGroupingControl1.DataSource = GetTable();
			this.gridGroupingControl1.ShowGroupDropArea = true; 
			this.gridGroupingControl1.TableDescriptor.Columns[0].HeaderText = "Identity";  

			//1. Set lookup by ComboBox list 
			DataTable lookUpDataTable=GetCountryTable();
			string ColumnName="Country";
			GridTableDescriptor td = this.gridGroupingControl1.TableDescriptor;
			td.Columns[ColumnName].HeaderText = "Contry Name";
			td.Columns[ColumnName].Appearance.AnyRecordFieldCell.CellType ="ComboBox";
			td.Columns[ColumnName].Appearance.AnyRecordFieldCell.DataSource=lookUpDataTable;
			td.Columns[ColumnName].Appearance.AnyRecordFieldCell.DisplayMember="description";
			td.Columns[ColumnName].Appearance.AnyRecordFieldCell.ValueMember="code";
			td.Columns[ColumnName].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.ShowCurrentCell;
			td.Columns[ColumnName].Appearance.AnyRecordFieldCell.HorizontalAlignment=GridHorizontalAlignment.Left;
			td.Columns[ColumnName].Appearance.AnyRecordFieldCell.DropDownStyle=GridDropDownStyle.Exclusive;

//			// 2. Set Lookup by FK Relateship
//			DataTable lookUpDataTable = this.GetCountryTable();
//			SetLookup(lookUpDataTable,"Country","description","code");

			//set summary
			GridSummaryColumnDescriptor column = new GridSummaryColumnDescriptor("PopulationSummary",SummaryType.Int32Aggregate,"Population","{Sum:##.##}"); 
			GridSummaryRowDescriptor row = new GridSummaryRowDescriptor("PopulationRow1");
			row.Title = "Sum";
			row.SummaryColumns.Add(column);  
			this.gridGroupingControl1.TableDescriptor.SummaryRows.Add(row);    


			column = new GridSummaryColumnDescriptor("PopulationAverage",SummaryType.Int32Aggregate,"Population","{Average:##.##}"); 
			row = new GridSummaryRowDescriptor("PopulationRow2");
			row.Title = "Average";
			row.SummaryColumns.Add(column);  
			this.gridGroupingControl1.TableDescriptor.SummaryRows.Add(row);  

			column = new GridSummaryColumnDescriptor("ExpenseSummary",SummaryType.Int32Aggregate,"Expense","{Sum:##.##}"); 
			row = new GridSummaryRowDescriptor("ExpenseRow1");
			row.Title = "Sum";
			row.SummaryColumns.Add(column);  
			this.gridGroupingControl1.TableDescriptor.SummaryRows.Add(row);  

			column = new GridSummaryColumnDescriptor("ExpenseSummary",SummaryType.Int32Aggregate,"Expense","{Average:##.##}"); 
			row = new GridSummaryRowDescriptor("ExpenseRow2");
			row.Title = "Average";
			row.SummaryColumns.Add(column);  
			this.gridGroupingControl1.TableDescriptor.SummaryRows.Add(row);  

					
		}


		# region  [   DataTable    ]
		private DataTable GetTable()
		{
			DataTable dt = new DataTable("MyTable");
			DataColumn column = new DataColumn("ID",typeof(int));
			column.AutoIncrement = true;
			column.AutoIncrementSeed =1;
			column.AutoIncrementStep =1;
			column.ReadOnly = true;

			dt.Columns.Add(column);
			dt.Columns.Add("State");
			dt.Columns.Add("Country");
			dt.Columns.Add("Population");
			dt.Columns.Add("Expense");

			dt.Rows.Add(new object[] {1,"NewJessy","USA",1234,582740});
			dt.Rows.Add(new object[] {2,"NewYork","USA",1224,582210});
			dt.Rows.Add(new object[] {3,"NC","USA",1123,51120});
			dt.Rows.Add(new object[] {4,"ABG","USA",856,122740});
			dt.Rows.Add(new object[] {5,"Ike","USA",256,6740});

			dt.Rows.Add(new object[] {6,"Delhi","IND",1234,582740});
			dt.Rows.Add(new object[] {7,"Mumbai","IND",1224,582210});
			dt.Rows.Add(new object[] {8,"Calcutta","IND",1123,51120});
			dt.Rows.Add(new object[] {9,"Chennai","IND",856,122740});
			

			dt.Rows.Add(new object[] {10,"Toronto","CAN",1234,582740});
			dt.Rows.Add(new object[] {11,"Waterloo","CAN",1224,582210});
			dt.Rows.Add(new object[] {12,"Cambridge","CAN",1123,51120});
			dt.Rows.Add(new object[] {13,"Kitchener","CAN",856,122740});


			dt.Rows.Add(new object[] {14,"Shanghai","CHN",1234,582740});
			dt.Rows.Add(new object[] {15,"Nanjing","CHN",1224,582210});
			dt.Rows.Add(new object[] {16,"Suzhou","CHN",1123,51120});
			dt.Rows.Add(new object[] {17,"Xian","CHN",856,122740});


			return dt;
		}

		private DataTable GetCountryTable()
		{
			DataTable dt = new DataTable("country");
			dt.Columns.Add("code");
			dt.Columns.Add("description");
			dt.Rows.Add(new object[] {"USA","The United States"});
			dt.Rows.Add(new object[] {"IND","India"});
			dt.Rows.Add(new object[] {"CAN","Canada"});
			dt.Rows.Add(new object[] {"CHN","The People's Republic of China"});
			dt.AcceptChanges();
			return dt;
		}
		#endregion

		private void button1_Click(object sender, System.EventArgs e)
		{
			GroupingGrid.GroupingGridExcelConverterControlExt converter = new GroupingGrid.GroupingGridExcelConverterControlExt();

			SaveFileDialog saveFileDialog = new SaveFileDialog();
			saveFileDialog.Filter = "Files(*.xls)|*.xls";
			saveFileDialog.DefaultExt = ".xls";

			if(saveFileDialog.ShowDialog() == DialogResult.OK)
			{
				this.gridGroupingControl1.Table.ExpandAllGroups();
				converter.GroupingGridToExcel(this.gridGroupingControl1, saveFileDialog.FileName, 
					Syncfusion.GridExcelConverter.ConverterOptions.Default);  
				
				if(MessageBox.Show("Do you wish to open the xls file now?", "Export to Excel", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
				{
					Process proc = new Process();
					proc.StartInfo.FileName = saveFileDialog.FileName;
					proc.Start();
				}
			}
		}

		Hashtable NewAddedRecordID = new Hashtable();
		private void gridGroupingControl1_SourceListRecordChanged(object sender, Syncfusion.Grouping.RecordChangedEventArgs e)
		{
			if( e.Action == RecordChangedType.Added )
			{
				DataTable dt = this.gridGroupingControl1.DataSource as DataTable;    
				dt.Columns["ID"].ReadOnly = false; 
				DataRowView row = e.Record.GetData() as DataRowView;
				row.Row[0]= DBNull.Value ; 
				dt.Columns["ID"].ReadOnly = true; 
			}
		}

		private void gridGroupingControl1_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{
			// change group value to desc
			if(e.Style.TableCellIdentity.TableCellType == GridTableCellType.GroupCaptionCell)
			{
				GridCaptionRow capRow = e.Style.TableCellIdentity.DisplayElement as GridCaptionRow;
				Group g = capRow.ParentGroup;
				if ( g!=null && g.Category!=null)
				{
					string sText=e.Style.Text;		//e.g. "Contry Name: CAN - 4 Items"
					string sFieldName=g.Name;		//Group column name
					string sFieldVal = g.Category.ToString();  //group column value
					e.Style.Text=ReplaceCodeWithDesc(sText,sFieldName,sFieldVal);
				}
			}
		}

		private string ReplaceCodeWithDesc(string Text,string ColumnName,string CodeValue)
		{
			
			GridTableDescriptor td = this.gridGroupingControl1.TableDescriptor;

			// if it is not combobox lookup column, no need to replace code with description
			if (td.Columns[ColumnName].Appearance.AnyRecordFieldCell.CellType !="ComboBox") return Text;



			// for combobox lookup column, find description based on the code from lookup table
			DataTable tdLookup=	td.Columns[ColumnName].Appearance.AnyRecordFieldCell.DataSource as DataTable;
			string sCodeField=td.Columns[ColumnName].Appearance.AnyRecordFieldCell.ValueMember;
			string sDescField=td.Columns[ColumnName].Appearance.AnyRecordFieldCell.DisplayMember;
			DataRow[] rows=tdLookup.Select(string.Format("{0}='{1}'",sCodeField,CodeValue));
			if (rows.Length>0)
			{
				string sDesc=rows[0][sDescField].ToString();
				return Text.Replace(CodeValue,sDesc);;
			}
			else
				return Text;
					
			
		}


		//      Set Lookup by FK Relateship
		//		private void SetLookup(DataTable lookUpDataTable,
		//			string LookUpCol,string DisplayCol,string IdCol)
		//		{
		//			//We are going to display a column named DisplayCol in the foreign
		//			//table where a column named LookUpCol is located in teh main table.
		//			//LookUpCol holds keys values that match the values in a column
		//			//named IdCol in the foriegn table. The steps are:
		//			// 1. Save the location of the maintable.LookUpCol column so it can be swapped
		//			//    after the foreign table reference has been set up
		//			// 2. Add the foreign table to the Engine's SourceList
		//			// 3. Create and setup a RelationKind.ForeignKeyReference relation
		//			// 4. Set any optional properties on the relation
		//			// 5. Add relation descriptor to main tabledescriptor
		//			// 6. Replace maintable.LookUpCol with foreigntable.DisplayCol
		//
		//
		//			//step 1. remember the location of lookupcol so it can be swapped out later
		//			GridTableDescriptor td = this.gridGroupingControl1.TableDescriptor;
		//			td.VisibleColumns.LoadDefault();
		//			int lookUpIndex = td.VisibleColumns.IndexOf(LookUpCol);
		//			string ColumnHeader=td.Columns[LookUpCol].HeaderText;
		//			
		//			//get the lookup table
		//			//DataTable lookUpDataTable = this.GetForeignTable();
		//
		//			//			DataSet ds2 = new DataSet("LookUp");
		//			//			ds2.Tables.Add(lookUpDataTable);
		//			
		//			//step 2. add it to the grouping engine
		//			this.gridGroupingControl1.Engine.SourceListSet.Add(lookUpDataTable.TableName, lookUpDataTable.DefaultView);
		//
		//			//step 3. Create and setup a RelationKind.ForeignKeyReference relation
		//
		//			//set up relation descriptor that defines mapping between main table and foreign table
		//			GridRelationDescriptor rd = new GridRelationDescriptor();
		//			rd.Name = LookUpCol+"2Display"; //just some unique name
		//			rd.RelationKind = RelationKind.ForeignKeyReference; //foreign key look up
		//			rd.ChildTableName = lookUpDataTable.TableName;  // SourceListSet name for lookup
		//
		//			//get foreign key for col "IdCol" in foreign table
		//			rd.RelationKeys.Add(LookUpCol, IdCol); //col in main table,  foreign key col
		//
		//
		//			//step 4. Set any optional properties on the relation
		//			// dropdown only shows DisplayCol
		//			rd.ChildTableDescriptor.VisibleColumns.Add(DisplayCol); //display column
		//			rd.ChildTableDescriptor.SortedColumns.Add(DisplayCol); //sort it for dropdown display
		//			rd.ChildTableDescriptor.AllowEdit = false; //no editing of foreign table
		//			rd.ChildTableDescriptor.AllowNew = false;  //no new items added to foreign table
		//			rd.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.Beige;
		//			
		//
		//			//no dropdown button in columns
		//			//td.TableOptions.AllowForeignKeyDropDown = false; 
		//
		//			//step 5. add relation descriptor to main tabledescriptor
		//			td.Relations.Add(rd);
		//			td.Columns.LoadDefault();  
		//
		//			//step 6. Replace maintable.LookUpCol with foreigntable.DisplayCol
		//			string foreignPrefix = rd.Name + "_";
		//			//get the hashed name of foreign col
		//			string foreignDisplayColInMainTable = foreignPrefix + DisplayCol; 
		//			td.VisibleColumns.Insert(lookUpIndex, foreignDisplayColInMainTable);
		//			//set its headertext to something other than default hashedname
		//			td.Columns[foreignDisplayColInMainTable].HeaderText = ColumnHeader;
		//			td.Columns[foreignDisplayColInMainTable].Appearance.AnyCell.BackColor = Color.LightGoldenrodYellow;
		//
		//		}
		//

	}
}
